Data Sort

In some conditions, you may only want to see the data in order like ascending, descending or in a customized order.

You can use the data sort in a report template cell to sort data in a specific order.

Description
app.js
index.html
styles.css
Copy to CodeMine
Open the demo in new window can open the designer

How to open desgnr

The sortOption interface is as follows:

type DataCellBase = {
    binding?: Binding;
    sortOptions?: SortOption[]; // can set multiple sort rule here.
};
type SortOption = ({
    asc: string;
} | {
    desc: string;
}) & {
    list?: string[]; // custom order list.
};

There are several uses for data sorting:

  1. Sort data by column value:

    You can specify which data column the current cellNode is sorted according to, then the currentNode and child node will reorder within the currentNode parent groups.

    const spread = new GC.Spread.Sheets.Workbook('ss', { sheetCount: 1 });
    const ordersTable = spread.dataManager().addTable('Orders', {
        remote: {
            read: {
                url: 'https://demodata.mescius.io/northwind/api/v1/orders'
            }
        }
    });
    ordersTable.fetch().then(() => {
        const reportSheet = spread.addSheetTab(0, 'report1', GC.Spread.Sheets.SheetType.reportSheet);
        const templateSheet = reportSheet.getTemplate();
        // set value and binding for the template
        templateSheet.setTemplateCell(1, 0, {
            type: 'List',
            binding: `Orders[customerId]`,
            sortOptions: [ // orderBy freight asc then by shipName asc.
                {
                    asc: "freight"
                },
                {
                    asc: "shipName"
                }
            ]
        });
        templateSheet.setTemplateCell(1, 1, {
            type: 'List',
            binding: `Orders[freight]`,
        });
        templateSheet.setTemplateCell(1, 2, {
            type: 'List',
            binding: `Orders[shipName]`,
        });
        reportSheet.refresh();
    });
    
  2. Sort data by cell:

    You can specify which cellNode value the current cellNode is sorted according to; the cellNode value must be the current cellNode child. If there are multiple values in the referred cellNode, it will use the first value.

    If the referred cellNode is the current cellNode itself, it will sort by the current cell value.

    templateSheet.setTemplateCell(1, 0, {
        type: 'List',
        binding: `Orders[customerId]`,
        sortOptions: [
            {
                desc: "=A2"
            }
        ]
    });
    
  3. Sort data by formula:

    You can use the formula as a sorting option to sort data by the formula calculation result:

    templateSheet.setTemplateCell(1, 0, {
        type: 'List',
        binding: 'Orders[orderDate]',
        sortOptions: [
            {
                desc: "=YEAR([@orderDate])"
            },
            {
                asc: "=YEAR([@orderDate])"
            }
        ]
    });
    templateSheet.setTemplateCell(1, 1, {
        type: "List",
        binding: "Orders[freight]",
    });
    
  4. Sort data by a list:

    You can use a specified value array in each sort option, then the sort result will order by the list order first, then in ascending/descending order.

    templateSheet.setTemplateCell(1, 0, {
        type: 'List',
        binding: 'Orders[CustomerId]',
        sortOptions: [
            {
                asc: "customerId",
                list: ["VINET", "TOMSP"]
            }
        ]
    });
    templateSheet.setTemplateCell(1, 1, {
        type: "List",
        binding: "Orders[freight]",
    });
    
Open the demo in new window can open the designer The sortOption interface is as follows: There are several uses for data sorting: Sort data by column value: You can specify which data column the current cellNode is sorted according to, then the currentNode and child node will reorder within the currentNode parent groups. Sort data by cell: You can specify which cellNode value the current cellNode is sorted according to; the cellNode value must be the current cellNode child. If there are multiple values in the referred cellNode, it will use the first value. If the referred cellNode is the current cellNode itself, it will sort by the current cell value. Sort data by formula: You can use the formula as a sorting option to sort data by the formula calculation result: Sort data by a list: You can use a specified value array in each sort option, then the sort result will order by the list order first, then in ascending/descending order.
window.onload = async () => { const loadingTip = addLoadingTip(); const { spread, designer } = createSpreadAndDesigner(); const res = await fetch('$DEMOROOT$/en/sample/features/report-sheet/data-settings/data-sort/spread.json'); await spread.fromJSON(correctTableUrl(await res.json())); loadingTip.remove(); if (designer) { designer.refresh(); } } function createSpreadAndDesigner() { const demoHost = document.getElementById('demo-host'); if (window !== top) { return { spread: new GC.Spread.Sheets.Workbook(demoHost, { sheetCount: 1 }), } } else { const designer = new GC.Spread.Sheets.Designer.Designer(demoHost, undefined, undefined, { sheetCount: 1 }); return { designer, spread: designer.getWorkbook(), } } } function addLoadingTip() { const div = document.createElement('div'); div.style.position = 'absolute'; div.style.inset = '0'; div.style.display = 'flex'; div.style.alignItems = 'center'; div.style.justifyContent = 'center'; div.style.background = 'white'; div.style.zIndex = '100'; div.textContent = 'Loading data from server ...'; document.body.appendChild(div); return div; } function correctTableUrl(json) { const baseUrl = '$DEMOROOT$'; const localUrl = 'http://localhost:8070/spreadjs/demos'; const replaceUrl = (obj) => { if (obj && obj.url && obj.url.startsWith(localUrl)) { obj.url = obj.url.replace(localUrl, baseUrl); } } if (json.dataManager && json.dataManager.tables) { json.dataManager.tables.forEach((table) => { if (table.dataSourceOption && table.dataSourceOption.remote) { Object.values(table.dataSourceOption.remote).forEach(replaceUrl); } }); } return json; }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-designer/styles/gc.spread.sheets.designer.min.css"> <link rel="stylesheet" type="text/css" href="styles.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-print/dist/gc.spread.sheets.print.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-charts/dist/gc.spread.sheets.charts.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-reportsheet-addon/dist/gc.spread.report.reportsheet.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script> const designerDependencyScripts = [ '$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-barcode/dist/gc.spread.sheets.barcode.min.js', '$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-pdf/dist/gc.spread.sheets.pdf.min.js', '$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-pivot-addon/dist/gc.spread.pivot.pivottables.min.js', '$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-slicers/dist/gc.spread.sheets.slicers.min.js', '$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-tablesheet/dist/gc.spread.sheets.tablesheet.min.js', '$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-ganttsheet/dist/gc.spread.sheets.ganttsheet.min.js', '$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-formula-panel/dist/gc.spread.sheets.formulapanel.min.js', '$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-io/dist/gc.spread.sheets.io.min.js', '$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-designer-resources-en/dist/gc.spread.sheets.designer.resource.en.min.js', '$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-designer/dist/gc.spread.sheets.designer.all.min.js', '$DEMOROOT$/spread/source/js/designer/license.js', ] function appendScriptNode (src) { const script = document.createElement('script'); script.src = src; script.async = false; script.type = 'text/javascript'; document.head.appendChild(script); } if (top === window) { // not in iframe designerDependencyScripts.forEach(appendScriptNode); } </script> <script src="app.js" type="text/javascript"></script> </head> <body> <div class="sample-tutorial"> <div id="demo-host"></div> </div> </body> </html>
body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } #demo-host { width: 100%; height: 100%; overflow: hidden; float: left; }

Data Sort

In some conditions, you may only want to see the data in order like ascending, descending or in a customized order.

You can use the data sort in a report template cell to sort data in a specific order.

Description
app.component.ts
index.html
app.component.html
styles.css
Copy to CodeMine
Open the demo in new window can open the designer

How to open desgnr

The sortOption interface is as follows:

type DataCellBase = {
    binding?: Binding;
    sortOptions?: SortOption[]; // can set multiple sort rule here.
};
type SortOption = ({
    asc: string;
} | {
    desc: string;
}) & {
    list?: string[]; // custom order list.
};

There are several uses for data sorting:

  1. Sort data by column value:

    You can specify which data column the current cellNode is sorted according to, then the currentNode and child node will reorder within the currentNode parent groups.

    const spread = new GC.Spread.Sheets.Workbook('ss', { sheetCount: 1 });
    const ordersTable = spread.dataManager().addTable('Orders', {
        remote: {
            read: {
                url: 'https://demodata.mescius.io/northwind/api/v1/orders'
            }
        }
    });
    ordersTable.fetch().then(() => {
        const reportSheet = spread.addSheetTab(0, 'report1', GC.Spread.Sheets.SheetType.reportSheet);
        const templateSheet = reportSheet.getTemplate();
        // set value and binding for the template
        templateSheet.setTemplateCell(1, 0, {
            type: 'List',
            binding: `Orders[customerId]`,
            sortOptions: [ // orderBy freight asc then by shipName asc.
                {
                    asc: "freight"
                },
                {
                    asc: "shipName"
                }
            ]
        });
        templateSheet.setTemplateCell(1, 1, {
            type: 'List',
            binding: `Orders[freight]`,
        });
        templateSheet.setTemplateCell(1, 2, {
            type: 'List',
            binding: `Orders[shipName]`,
        });
        reportSheet.refresh();
    });
    
  2. Sort data by cell:

    You can specify which cellNode value the current cellNode is sorted according to; the cellNode value must be the current cellNode child. If there are multiple values in the referred cellNode, it will use the first value.

    If the referred cellNode is the current cellNode itself, it will sort by the current cell value.

    templateSheet.setTemplateCell(1, 0, {
        type: 'List',
        binding: `Orders[customerId]`,
        sortOptions: [
            {
                desc: "=A2"
            }
        ]
    });
    
  3. Sort data by formula:

    You can use the formula as a sorting option to sort data by the formula calculation result:

    templateSheet.setTemplateCell(1, 0, {
        type: 'List',
        binding: 'Orders[orderDate]',
        sortOptions: [
            {
                desc: "=YEAR([@orderDate])"
            },
            {
                asc: "=YEAR([@orderDate])"
            }
        ]
    });
    templateSheet.setTemplateCell(1, 1, {
        type: "List",
        binding: "Orders[freight]",
    });
    
  4. Sort data by a list:

    You can use a specified value array in each sort option, then the sort result will order by the list order first, then in ascending/descending order.

    templateSheet.setTemplateCell(1, 0, {
        type: 'List',
        binding: 'Orders[CustomerId]',
        sortOptions: [
            {
                asc: "customerId",
                list: ["VINET", "TOMSP"]
            }
        ]
    });
    templateSheet.setTemplateCell(1, 1, {
        type: "List",
        binding: "Orders[freight]",
    });
    
Open the demo in new window can open the designer The sortOption interface is as follows: There are several uses for data sorting: Sort data by column value: You can specify which data column the current cellNode is sorted according to, then the currentNode and child node will reorder within the currentNode parent groups. Sort data by cell: You can specify which cellNode value the current cellNode is sorted according to; the cellNode value must be the current cellNode child. If there are multiple values in the referred cellNode, it will use the first value. If the referred cellNode is the current cellNode itself, it will sort by the current cell value. Sort data by formula: You can use the formula as a sorting option to sort data by the formula calculation result: Sort data by a list: You can use a specified value array in each sort option, then the sort result will order by the list order first, then in ascending/descending order.
import { Component, NgModule, enableProdMode } from '@angular/core'; import { BrowserModule } from '@angular/platform-browser'; import { platformBrowserDynamic } from '@angular/platform-browser-dynamic'; import { SpreadSheetsModule } from '@mescius/spread-sheets-angular'; import GC from '@mescius/spread-sheets'; import '@mescius/spread-sheets-print'; import '@mescius/spread-sheets-shapes'; import '@mescius/spread-sheets-charts'; import '@mescius/spread-sheets-reportsheet-addon'; import '@mescius/spread-sheets-tablesheet'; import '@mescius/spread-sheets-ganttsheet'; import '@mescius/spread-sheets-formula-panel'; import '@mescius/spread-sheets-designer-resources-en'; import '@mescius/spread-sheets-designer'; import { DesignerModule } from "@mescius/spread-sheets-designer-angular"; import './styles.css'; import '$DEMOROOT$/spread/source/js/angular/license.ts'; import { registerlic } from '$DEMOROOT$/spread/source/js/designer/react_vue/license.js'; registerlic(GC); @Component({ selector: 'app-component', templateUrl: 'src/app.component.html' }) export class AppComponent { showDesigner = top === window; props = {}; hostStyle: any; constructor() { if (!this.showDesigner) { this.hostStyle = { width: '100%', height: '100%', overflow: 'hidden', float: 'left' }; } } initDesigner($event) { initDesigner($event.designer); } initSpread($event) { initSpread($event.spread); } } async function initDesigner(designer) { await initSpread(designer.getWorkbook()); designer.refresh(); } async function initSpread(spread) { spread.suspendPaint(); spread.setSheetCount(1); const loadingTip = addLoadingTip(); const res = await fetch('$DEMOROOT$/en/sample/features/report-sheet/data-settings/data-sort/spread.json'); await spread.fromJSON(correctTableUrl(await res.json())); loadingTip.remove(); spread.resumePaint(); } function addLoadingTip() { const div = document.createElement('div'); div.style.position = 'absolute'; div.style.inset = '0'; div.style.display = 'flex'; div.style.alignItems = 'center'; div.style.justifyContent = 'center'; div.style.background = 'white'; div.style.zIndex = '100'; div.textContent = 'Loading data from server ...'; document.body.appendChild(div); return div; } function correctTableUrl(json) { const baseUrl = '$DEMOROOT$'; const localUrl = 'http://localhost:8070/spreadjs/demos'; const replaceUrl = (obj) => { if (obj && obj.url && obj.url.startsWith(localUrl)) { obj.url = obj.url.replace(localUrl, baseUrl); } } if (json.dataManager && json.dataManager.tables) { json.dataManager.tables.forEach((table) => { if (table.dataSourceOption && table.dataSourceOption.remote) { Object.values(table.dataSourceOption.remote).forEach(replaceUrl); } }); } return json; } @NgModule({ imports: [BrowserModule, SpreadSheetsModule, DesignerModule], declarations: [AppComponent], exports: [AppComponent], bootstrap: [AppComponent] }) export class AppModule { } enableProdMode(); // Bootstrap application with hash style navigation and global services. platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets-designer/styles/gc.spread.sheets.designer.min.css"> <!-- Polyfills --> <script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script> <script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script> <!-- SystemJS --> <script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script> <script src="systemjs.config.js"></script> <script> // workaround to load 'rxjs/operators' from the rxjs bundle System.import('rxjs').then(function (m) { System.import('@angular/compiler'); System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators)); System.import('./src/app.component'); }); </script> </head> <body> <app-component></app-component> </body> </html>
<div class="sample-tutorial"> <designer *ngIf="showDesigner" [props]="props" (designerInitialized)="initDesigner($event)"></designer> <gc-spread-sheets *ngIf="!showDesigner" [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)"></gc-spread-sheets> </div>
body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .gc-designer-container { height: 100%; width: 100%; }
(function (global) { System.config({ transpiler: 'ts', typescriptOptions: { tsconfig: true }, meta: { 'typescript': { "exports": "ts" }, '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { 'core-js': 'npm:core-js/client/shim.min.js', 'zone': 'npm:zone.js/fesm2015/zone.min.js', 'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js', '@angular/core': 'npm:@angular/core/fesm2022', '@angular/common': 'npm:@angular/common/fesm2022/common.mjs', '@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs', '@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs', '@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs', '@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs', '@angular/router': 'npm:@angular/router/fesm2022/router.mjs', '@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs', 'jszip': 'npm:jszip/dist/jszip.min.js', 'typescript': 'npm:typescript/lib/typescript.js', 'ts': './plugin.js', 'tslib':'npm:tslib/tslib.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js', '@mescius/spread-sheets-designer-resources-en': 'npm:@mescius/spread-sheets-designer-resources-en/index.js', '@mescius/spread-sheets-designer': 'npm:@mescius/spread-sheets-designer/index.js', '@mescius/spread-sheets-designer-angular': 'npm:@mescius/spread-sheets-designer-angular/fesm2020/mescius-spread-sheets-designer-angular.mjs', '@mescius/spread-excelio': 'npm:@mescius/spread-excelio/index.js', '@mescius/spread-sheets-barcode': 'npm:@mescius/spread-sheets-barcode/index.js', '@mescius/spread-sheets-charts': 'npm:@mescius/spread-sheets-charts/index.js', '@mescius/spread-sheets-languagepackages': 'npm:@mescius/spread-sheets-languagepackages/index.js', '@mescius/spread-sheets-print': 'npm:@mescius/spread-sheets-print/index.js', '@mescius/spread-sheets-pdf': 'npm:@mescius/spread-sheets-pdf/index.js', '@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js', '@mescius/spread-sheets-io': 'npm:@mescius/spread-sheets-io/index.js', '@mescius/spread-sheets-reportsheet-addon': 'npm:@mescius/spread-sheets-reportsheet-addon/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js', '@mescius/spread-sheets-ganttsheet': 'npm:@mescius/spread-sheets-ganttsheet/index.js', '@mescius/spread-sheets-formula-panel': 'npm:@mescius/spread-sheets-formula-panel/index.js', '@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs', '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'ts' }, rxjs: { defaultExtension: 'js' }, "node_modules": { defaultExtension: 'js' }, "node_modules/@angular": { defaultExtension: 'mjs' }, "@mescius/spread-sheets-angular": { defaultExtension: 'mjs' }, "@mescius/spread-sheets-designer-angular": { defaultExtension: 'mjs' }, '@angular/core': { defaultExtension: 'mjs', main: 'core.mjs' } } }); })(this);

Data Sort

In some conditions, you may only want to see the data in order like ascending, descending or in a customized order.

You can use the data sort in a report template cell to sort data in a specific order.

Description
app.vue
index.html
Copy to CodeMine
Open the demo in new window can open the designer

How to open desgnr

The sortOption interface is as follows:

type DataCellBase = {
    binding?: Binding;
    sortOptions?: SortOption[]; // can set multiple sort rule here.
};
type SortOption = ({
    asc: string;
} | {
    desc: string;
}) & {
    list?: string[]; // custom order list.
};

There are several uses for data sorting:

  1. Sort data by column value:

    You can specify which data column the current cellNode is sorted according to, then the currentNode and child node will reorder within the currentNode parent groups.

    const spread = new GC.Spread.Sheets.Workbook('ss', { sheetCount: 1 });
    const ordersTable = spread.dataManager().addTable('Orders', {
        remote: {
            read: {
                url: 'https://demodata.mescius.io/northwind/api/v1/orders'
            }
        }
    });
    ordersTable.fetch().then(() => {
        const reportSheet = spread.addSheetTab(0, 'report1', GC.Spread.Sheets.SheetType.reportSheet);
        const templateSheet = reportSheet.getTemplate();
        // set value and binding for the template
        templateSheet.setTemplateCell(1, 0, {
            type: 'List',
            binding: `Orders[customerId]`,
            sortOptions: [ // orderBy freight asc then by shipName asc.
                {
                    asc: "freight"
                },
                {
                    asc: "shipName"
                }
            ]
        });
        templateSheet.setTemplateCell(1, 1, {
            type: 'List',
            binding: `Orders[freight]`,
        });
        templateSheet.setTemplateCell(1, 2, {
            type: 'List',
            binding: `Orders[shipName]`,
        });
        reportSheet.refresh();
    });
    
  2. Sort data by cell:

    You can specify which cellNode value the current cellNode is sorted according to; the cellNode value must be the current cellNode child. If there are multiple values in the referred cellNode, it will use the first value.

    If the referred cellNode is the current cellNode itself, it will sort by the current cell value.

    templateSheet.setTemplateCell(1, 0, {
        type: 'List',
        binding: `Orders[customerId]`,
        sortOptions: [
            {
                desc: "=A2"
            }
        ]
    });
    
  3. Sort data by formula:

    You can use the formula as a sorting option to sort data by the formula calculation result:

    templateSheet.setTemplateCell(1, 0, {
        type: 'List',
        binding: 'Orders[orderDate]',
        sortOptions: [
            {
                desc: "=YEAR([@orderDate])"
            },
            {
                asc: "=YEAR([@orderDate])"
            }
        ]
    });
    templateSheet.setTemplateCell(1, 1, {
        type: "List",
        binding: "Orders[freight]",
    });
    
  4. Sort data by a list:

    You can use a specified value array in each sort option, then the sort result will order by the list order first, then in ascending/descending order.

    templateSheet.setTemplateCell(1, 0, {
        type: 'List',
        binding: 'Orders[CustomerId]',
        sortOptions: [
            {
                asc: "customerId",
                list: ["VINET", "TOMSP"]
            }
        ]
    });
    templateSheet.setTemplateCell(1, 1, {
        type: "List",
        binding: "Orders[freight]",
    });
    
Open the demo in new window can open the designer The sortOption interface is as follows: There are several uses for data sorting: Sort data by column value: You can specify which data column the current cellNode is sorted according to, then the currentNode and child node will reorder within the currentNode parent groups. Sort data by cell: You can specify which cellNode value the current cellNode is sorted according to; the cellNode value must be the current cellNode child. If there are multiple values in the referred cellNode, it will use the first value. If the referred cellNode is the current cellNode itself, it will sort by the current cell value. Sort data by formula: You can use the formula as a sorting option to sort data by the formula calculation result: Sort data by a list: You can use a specified value array in each sort option, then the sort result will order by the list order first, then in ascending/descending order.
<template> <gc-spread-sheets-designer class="demo" v-if="showDesigner" @designerInitialized="initDesigner" /> <gc-spread-sheets class="demo" v-else @workbookInitialized="initSpread" /> </template> <script setup> import GC from '@mescius/spread-sheets'; import '@mescius/spread-sheets-print'; import '@mescius/spread-sheets-shapes'; import '@mescius/spread-sheets-charts'; import '@mescius/spread-sheets-reportsheet-addon'; import '@mescius/spread-sheets-tablesheet'; import '@mescius/spread-sheets-ganttsheet'; import '@mescius/spread-sheets-formula-panel'; import '@mescius/spread-sheets-vue'; import '@mescius/spread-sheets-designer-resources-en'; import '@mescius/spread-sheets-designer-vue'; import { ref } from 'vue'; import '$DEMOROOT$/spread/source/js/react_vue/license.js'; import { registerlic } from '$DEMOROOT$/spread/source/js/designer/react_vue/license.js'; registerlic(GC); const showDesigner = top === window; const spreadRef = ref(null); const designerRef = ref(null); async function initDesigner(designer) { designerRef.value = designer; await initSpread(designer.getWorkbook()); designer.refresh(); } async function initSpread(spread) { spreadRef.value = spread; spread.suspendPaint(); spread.setSheetCount(1); const loadingTip = addLoadingTip(); const res = await fetch('$DEMOROOT$/en/sample/features/report-sheet/data-settings/data-sort/spread.json'); await spread.fromJSON(correctTableUrl(await res.json())); loadingTip.remove(); spread.resumePaint(); } function addLoadingTip() { const div = document.createElement('div'); div.style.position = 'absolute'; div.style.inset = '0'; div.style.display = 'flex'; div.style.alignItems = 'center'; div.style.justifyContent = 'center'; div.style.background = 'white'; div.style.zIndex = '100'; div.textContent = 'Loading data from server ...'; document.body.appendChild(div); return div; } function correctTableUrl(json) { const baseUrl = '$DEMOROOT$'; const localUrl = 'http://localhost:8070/spreadjs/demos'; const replaceUrl = (obj) => { if (obj && obj.url && obj.url.startsWith(localUrl)) { obj.url = obj.url.replace(localUrl, baseUrl); } } if (json.dataManager && json.dataManager.tables) { json.dataManager.tables.forEach((table) => { if (table.dataSourceOption && table.dataSourceOption.remote) { Object.values(table.dataSourceOption.remote).forEach(replaceUrl); } }); } return json; } </script> <style scoped> body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } #app { height: 100%; } .demo { width: 100%; height: 100%; overflow: hidden; } </style>
<!DOCTYPE html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <title>SpreadJS VUE</title> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets-designer/styles/gc.spread.sheets.designer.min.css"> <script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script> <script src="./systemjs.config.js"></script> <script src="./compiler.js" type="module"></script> <script> System.import("./src/app.js"); </script> </head> <body> <div id="app"></div> </body> </html>
(function (global) { SystemJS.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, packageConfigPaths: [ './node_modules/*/package.json', "./node_modules/@mescius/*/package.json", "./node_modules/@babel/*/package.json", "./node_modules/@vue/*/package.json" ], map: { 'vue': "npm:vue/dist/vue.esm-browser.js", 'tiny-emitter': 'npm:tiny-emitter/index.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', "systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js", '@mescius/spread-sheets-designer-resources-en': 'npm:@mescius/spread-sheets-designer-resources-en/index.js', '@mescius/spread-sheets-designer-vue': 'npm:@mescius/spread-sheets-designer-vue/index.js', '@mescius/spread-sheets-designer': 'npm:@mescius/spread-sheets-designer/index.js', '@mescius/spread-excelio': 'npm:@mescius/spread-excelio/index.js', '@mescius/spread-sheets-barcode': 'npm:@mescius/spread-sheets-barcode/index.js', '@mescius/spread-sheets-charts': 'npm:@mescius/spread-sheets-charts/index.js', '@mescius/spread-sheets-languagepackages': 'npm:@mescius/spread-sheets-languagepackages/index.js', '@mescius/spread-sheets-print': 'npm:@mescius/spread-sheets-print/index.js', '@mescius/spread-sheets-pdf': 'npm:@mescius/spread-sheets-pdf/index.js', '@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js', '@mescius/spread-sheets-io': 'npm:@mescius/spread-sheets-io/index.js', '@mescius/spread-sheets-reportsheet-addon': 'npm:@mescius/spread-sheets-reportsheet-addon/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js', '@mescius/spread-sheets-ganttsheet': 'npm:@mescius/spread-sheets-ganttsheet/index.js', '@mescius/spread-sheets-formula-panel': 'npm:@mescius/spread-sheets-formula-panel/index.js', '@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js', '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', }, meta: { '*.css': { loader: 'systemjs-plugin-css' }, '*.vue': { loader: "../plugin-vue/index.js" } } }); })(this);

Data Sort

In some conditions, you may only want to see the data in order like ascending, descending or in a customized order.

You can use the data sort in a report template cell to sort data in a specific order.

Description
app.jsx
app-func.jsx
index.html
styles.css
Copy to CodeMine
Open the demo in new window can open the designer

How to open desgnr

The sortOption interface is as follows:

type DataCellBase = {
    binding?: Binding;
    sortOptions?: SortOption[]; // can set multiple sort rule here.
};
type SortOption = ({
    asc: string;
} | {
    desc: string;
}) & {
    list?: string[]; // custom order list.
};

There are several uses for data sorting:

  1. Sort data by column value:

    You can specify which data column the current cellNode is sorted according to, then the currentNode and child node will reorder within the currentNode parent groups.

    const spread = new GC.Spread.Sheets.Workbook('ss', { sheetCount: 1 });
    const ordersTable = spread.dataManager().addTable('Orders', {
        remote: {
            read: {
                url: 'https://demodata.mescius.io/northwind/api/v1/orders'
            }
        }
    });
    ordersTable.fetch().then(() => {
        const reportSheet = spread.addSheetTab(0, 'report1', GC.Spread.Sheets.SheetType.reportSheet);
        const templateSheet = reportSheet.getTemplate();
        // set value and binding for the template
        templateSheet.setTemplateCell(1, 0, {
            type: 'List',
            binding: `Orders[customerId]`,
            sortOptions: [ // orderBy freight asc then by shipName asc.
                {
                    asc: "freight"
                },
                {
                    asc: "shipName"
                }
            ]
        });
        templateSheet.setTemplateCell(1, 1, {
            type: 'List',
            binding: `Orders[freight]`,
        });
        templateSheet.setTemplateCell(1, 2, {
            type: 'List',
            binding: `Orders[shipName]`,
        });
        reportSheet.refresh();
    });
    
  2. Sort data by cell:

    You can specify which cellNode value the current cellNode is sorted according to; the cellNode value must be the current cellNode child. If there are multiple values in the referred cellNode, it will use the first value.

    If the referred cellNode is the current cellNode itself, it will sort by the current cell value.

    templateSheet.setTemplateCell(1, 0, {
        type: 'List',
        binding: `Orders[customerId]`,
        sortOptions: [
            {
                desc: "=A2"
            }
        ]
    });
    
  3. Sort data by formula:

    You can use the formula as a sorting option to sort data by the formula calculation result:

    templateSheet.setTemplateCell(1, 0, {
        type: 'List',
        binding: 'Orders[orderDate]',
        sortOptions: [
            {
                desc: "=YEAR([@orderDate])"
            },
            {
                asc: "=YEAR([@orderDate])"
            }
        ]
    });
    templateSheet.setTemplateCell(1, 1, {
        type: "List",
        binding: "Orders[freight]",
    });
    
  4. Sort data by a list:

    You can use a specified value array in each sort option, then the sort result will order by the list order first, then in ascending/descending order.

    templateSheet.setTemplateCell(1, 0, {
        type: 'List',
        binding: 'Orders[CustomerId]',
        sortOptions: [
            {
                asc: "customerId",
                list: ["VINET", "TOMSP"]
            }
        ]
    });
    templateSheet.setTemplateCell(1, 1, {
        type: "List",
        binding: "Orders[freight]",
    });
    
Open the demo in new window can open the designer The sortOption interface is as follows: There are several uses for data sorting: Sort data by column value: You can specify which data column the current cellNode is sorted according to, then the currentNode and child node will reorder within the currentNode parent groups. Sort data by cell: You can specify which cellNode value the current cellNode is sorted according to; the cellNode value must be the current cellNode child. If there are multiple values in the referred cellNode, it will use the first value. If the referred cellNode is the current cellNode itself, it will sort by the current cell value. Sort data by formula: You can use the formula as a sorting option to sort data by the formula calculation result: Sort data by a list: You can use a specified value array in each sort option, then the sort result will order by the list order first, then in ascending/descending order.
import * as React from 'react'; import * as ReactDOM from 'react-dom'; import './styles.css'; import { AppFunc } from './app-func'; ReactDOM.render(<AppFunc />, document.getElementById('app'));
import * as React from 'react'; import * as ReactDOM from 'react-dom'; import { SpreadSheets } from '@mescius/spread-sheets-react'; import GC from '@mescius/spread-sheets'; import '@mescius/spread-sheets-print'; import '@mescius/spread-sheets-shapes'; import '@mescius/spread-sheets-charts'; import '@mescius/spread-sheets-reportsheet-addon'; import '@mescius/spread-sheets-tablesheet'; import '@mescius/spread-sheets-ganttsheet'; import '@mescius/spread-sheets-formula-panel'; import '@mescius/spread-sheets-designer-resources-en'; import { Designer } from '@mescius/spread-sheets-designer-react'; import './styles.css'; import '$DEMOROOT$/spread/source/js/react_vue/license.js'; import { registerlic } from '$DEMOROOT$/spread/source/js/designer/react_vue/license.js'; registerlic(GC); export function AppFunc() { return ( <div class='demo'> {top === window ? <Designer styleInfo={{ height: '100%' }} designerInitialized={initDesigner} /> : <SpreadSheets workbookInitialized={initSpread} />} </div> ); } async function initDesigner(designer) { await initSpread(designer.getWorkbook()); designer.refresh(); } async function initSpread(spread) { spread.suspendPaint(); spread.setSheetCount(1); const loadingTip = addLoadingTip(); const res = await fetch('$DEMOROOT$/en/sample/features/report-sheet/data-settings/data-sort/spread.json'); await spread.fromJSON(correctTableUrl(await res.json())); loadingTip.remove(); spread.resumePaint(); } function addLoadingTip() { const div = document.createElement('div'); div.style.position = 'absolute'; div.style.inset = '0'; div.style.display = 'flex'; div.style.alignItems = 'center'; div.style.justifyContent = 'center'; div.style.background = 'white'; div.style.zIndex = '100'; div.textContent = 'Loading data from server ...'; document.body.appendChild(div); return div; } function correctTableUrl(json) { const baseUrl = '$DEMOROOT$'; const localUrl = 'http://localhost:8070/spreadjs/demos'; const replaceUrl = (obj) => { if (obj && obj.url && obj.url.startsWith(localUrl)) { obj.url = obj.url.replace(localUrl, baseUrl); } } if (json.dataManager && json.dataManager.tables) { json.dataManager.tables.forEach((table) => { if (table.dataSourceOption && table.dataSourceOption.remote) { Object.values(table.dataSourceOption.remote).forEach(replaceUrl); } }); } return json; }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets-designer/styles/gc.spread.sheets.designer.min.css"> <script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script> <script src="systemjs.config.js"></script> <script> System.import('./src/app'); </script> </head> <body> <div id="app" style="height: 100%;"></div> </body> </html>
body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } .demo { width: 100%; height: 100%; overflow: hidden; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true, react: true }, meta: { '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { '@mescius/spread-sheets-designer-resources-en': 'npm:@mescius/spread-sheets-designer-resources-en/index.js', '@mescius/spread-sheets-designer-react': 'npm:@mescius/spread-sheets-designer-react/index.js', '@mescius/spread-sheets-designer': 'npm:@mescius/spread-sheets-designer/index.js', '@mescius/spread-excelio': 'npm:@mescius/spread-excelio/index.js', '@mescius/spread-sheets-barcode': 'npm:@mescius/spread-sheets-barcode/index.js', '@mescius/spread-sheets-charts': 'npm:@mescius/spread-sheets-charts/index.js', '@mescius/spread-sheets-languagepackages': 'npm:@mescius/spread-sheets-languagepackages/index.js', '@mescius/spread-sheets-print': 'npm:@mescius/spread-sheets-print/index.js', '@mescius/spread-sheets-pdf': 'npm:@mescius/spread-sheets-pdf/index.js', '@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js', '@mescius/spread-sheets-io': 'npm:@mescius/spread-sheets-io/index.js', '@mescius/spread-sheets-reportsheet-addon': 'npm:@mescius/spread-sheets-reportsheet-addon/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js', '@mescius/spread-sheets-ganttsheet': 'npm:@mescius/spread-sheets-ganttsheet/index.js', '@mescius/spread-sheets-formula-panel': 'npm:@mescius/spread-sheets-formula-panel/index.js', '@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js', '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js', 'react': 'npm:react/umd/react.production.min.js', 'react-dom': 'npm:react-dom/umd/react-dom.production.min.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'jsx' }, "node_modules": { defaultExtension: 'js' }, } }); })(this);